* System:  CN(A 2Pi)+NN (v=3 geom for Rcn), from UCCSD(T)-PES
* Reference: D. I. G. Bennett, in progress

      
      subroutine driver
      implicit double precision (a-h,o-z)
      common /cosysr/ xjunk(2),rshift,xfact
      common /covvl/ vvl(11)
      common /coconv/ econv
      include "common/parpot"
      potnam='BENNETT CN(A)-NN RCCSD(T)'

      econv=219474.6d0
1      print *, ' r (bohr)'
      rshift=0.5
      xfact=0.8
      read (5, *, end=99) r
      call pot(vv0,r)
      write (6, 100) vv0,vvl
100   format(' vsum',/,7(1pe16.8),/,
     :    '  vdif',/,5e16.8)
      goto 1
99    r=4
      write (2,*) 'Vsum CN(A)-Ar'
      do i=1,40
         call pot(vv0,r)
         write (2,101) r,vv0,(vvl(j), j=1,6)
101      format(f8.4,7(pe16.8))
         r=r+0.2d0
      enddo
      r=4
      write (2,*) 'Vdif CN(A)-Ar'
      do i=1,40
         call pot(vv0,r)
         write (2,102) r,(vvl(j), j=7,11)
102      format(7(pe16.8))
         r=r+0.2d0
      enddo
      end
      include "common/syusr"
      include "common/bausr"
      include "common/ground"
    
* --------------------------------------------------------------------------
      subroutine loapot(iunit,filnam)
* --------------------------------------------------------------------------
      character*(*) filnam
      include "common/parbas"
      include "common/parpot"
      potnam='BENNETT CN(A)-AR RCCSD(T)'
      lammin(1)=1
      lammax(1)=6
      lammin(2)=2
      lammax(2)=6
      mproj(1)=0
      mproj(2)=2
      ntv(1)=1
      ivcol(1,1)=0
      ivrow(1,1)=0
      return
      end
* ----------------------------------------------------------------------
      subroutine pot (vv0, r)
*  subroutine to calculate the r-dependent coefficients
*  in atomic units (distance and energy)
* ----------------------------------------------------------------------
*  on entry:
*    r:      interparticle distance
*  on return:
*  vv0        contains isotropic term (d00 term in vsum)
*  variable in common block /covvl/
*    vvl:     vector of length 6 to store r-dependence of each term
*             in potential expansion
*    vvl(1-6) expansion coefficients in dl0 (l=1:6) of vsum
*    vvl(7-11) expansion coefficients in dl2 (l=2:6) of vdif

* uses linear least squares routines from cmlib

* author:  millard alexander
* latest revision date:  21-Aug-1998
* ----------------------------------------------------------------------

      implicit double precision (a-h,o-z)
      dimension xlam1(13),xlam2(13),r0(13),c1(13),c2(13),c3(13),
     :          clr(13),vsum(7),xsum(7),vdif(7),xdif(7),
     :          ddif(7),vap(7),va2p(7),
     :          d0(49),d2(25),aa(64)
      dimension kpvt(8),qraux(7),work(55),rsd(7),re(14)

      common /covvl/ vvl(11)
      data half, zero, one, alph /0.5d0, 0.d0, 1.d0, 1.2d0/
* for distances beyond rmax difference potential is damped
      data rmax /25d0/
* coefficicients for d0 rotation matrices
* stored (by column) for each of 7 angles and for l=0:6
* angles are 0 30 60 90 120 150 180
      data d0/
     : 1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     : 1d0,  8.6602541d-1,  5.0000001d-1,  1.3349125d-8, -4.9999998d-1,
     : -8.6602539d-1, -1d0,
     : 1d0,  6.2500001d-1, -1.2499999d-1, -5.0000000d-1, -1.2500002d-1,
     : 6.2499997d-1,  1d0,
     : 1d0,  3.2475954d-1, -4.3750000d-1, -2.0023687d-8,  4.3750001d-1,
     : -3.2475948d-1, -1d0,
     : 1d0,  2.3437511d-2, -2.8906251d-1,  3.7500000d-1, -2.8906248d-1,
     : 2.3437446d-2,  1d0,
     : 1d0, -2.2327216d-1,  8.9843733d-2,  2.5029609d-8, -8.9843784d-2,
     : 2.2327222d-1, -1d0,
     : 1d0, -3.7402343d-1,  3.2324218d-1, -3.1250000d-1,  3.2324220d-1,
     : -3.7402346d-1,  1d0/
* coefficicients for d2 rotation matrices
* stored (by column) for each of 5 angles and for l=2:6
* angles are 30 60 90 120 150
      data d2/
     : 1.5309311d-1,  4.5927932d-1,  6.1237244d-1,  4.5927934d-1,
     : 1.5309312d-1,
     : 2.9646353d-1,  5.1348990d-1,  1.8279042d-8, -5.1348989d-1,
     : -2.9646355d-1,
     : 4.1999000d-1,  2.2234766d-1, -3.9528471d-1,  2.2234762d-1,
     : 4.1999002d-1,
     : 4.9023048d-1, -1.6982081d-1, -2.4180900d-8,  1.6982085d-1,
     : -4.9023049d-1,
     : 4.8532921d-1, -3.4523418d-1,  3.2021721d-1, -3.4523418d-1,
     : 4.8532920d-1/


*Need to name and define N1,M,N2 from Jacek's code here 	 

* determine A' and A" potentials at angles
	do 100 i=1,7
	  theta=(i-1)*30
	  vsum(i)=EVAL_PES_sum(r,theta)
	  if (i.ne.1) then
	  if (i.ne.7) then
	    vdif(i-1)=EVAL_PES_dif(r,theta)
	  endif
	  endif
*	  write (6,*) r, theta, vsum(i), vdif(i-1)
	  
* for long range damp out difference and sum potential
           if (r .gt. rmax) then
             damp=-half*(tanh(3.d0*(r-rmax))-one)
             vdif(i-1)=vdif(i-1)*damp
*			 vsum(i)=vsum(i)*damp
           endif
100   continue
* solve simultaneous equations for solutions
* first for vsigma
      tol=1.e-10
      call dcopy(49,d0,1,aa,1)
      call dqrank(aa,7,7,7,tol,kr,kpvt,qraux,work)
      call dqrlss(aa,7,7,7,kr,vsum,xsum,rsd,kpvt,qraux)
* convert to hartree
      conv=1.d0/219474.6
      call dscal(7,conv,xsum,1)
      vv0=xsum(1)
      call dcopy(6,xsum(2),1,vvl,1)
      call dcopy(25,d2,1,aa,1)
      call dqrank(aa,5,5,5,tol,kr,kpvt,qraux,work)
      call dqrlss(aa,5,5,5,kr,vdif,xdif,rsd,kpvt,qraux)
      call dscal(5,conv,xdif,1)
      call dcopy(5,xdif,1,vvl(7),1)
      end

*--------------------------------------------------------------------





*PES EVALUATION CALL (SUM)
      FUNCTION EVAL_PES_sum(RR,TT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      dimension rsource1(255),thetasource1(255),vcoef1(255)
      dimension vstack1(90),vstack2(90),vstack3(75)
 	  data rsource1/
     : 25, 24, 23, 22, 21, 
     : 20, 19, 18, 17, 16, 
     : 15, 14, 13, 12, 11.5, 
     : 11, 10.5, 10, 9.75, 9.5, 
     : 9.25, 9, 8.75, 8.5, 8.25, 
     : 8, 7.8, 7.6, 7.4, 7.2, 
     : 7, 6.8, 6.6, 6.4, 6.2, 
     : 25, 24, 23, 22, 21, 
     : 20, 19, 18, 17, 16, 
     : 15, 14, 13, 12, 11.5, 
     : 11, 10.5, 10, 9.75, 9.5, 
     : 9.25, 9, 8.75, 8.5, 8.25, 
     : 8, 7.8, 7.6, 7.4, 7.2, 
     : 7, 6.8, 6.6, 6.4, 6.2, 
     : 6, 25, 24, 23, 22, 
     : 21, 20, 19, 18, 17, 
     : 16, 15, 14, 13, 12, 
     : 11.5, 11, 10.5, 10, 9.75, 
     : 9.5, 9.25, 9, 8.75, 8.5, 
     : 8.25, 8, 7.8, 7.6, 7.4, 
     : 7.2, 7, 6.8, 6.6, 6.2, 
     : 6, 5.8, 25, 24, 23, 
     : 22, 21, 20, 19, 18, 
     : 17, 16, 15, 14, 13, 
     : 12, 11.5, 11, 10.5, 10, 
     : 9.75, 9.5, 9.25, 9, 8.75, 
     : 8.5, 8.25, 8, 7.8, 7.6, 
     : 7.4, 7.2, 7, 6.8, 6.6, 
     : 6.4, 6.2, 6, 5.8, 5.6, 
     : 25, 24, 23, 22, 21, 
     : 20, 19, 18, 17, 16, 
     : 15, 14, 13, 12, 11.5, 
     : 11, 10.5, 10, 9.75, 9.5, 
     : 9.25, 9, 8.75, 8.5, 8.25, 
     : 8, 7.8, 7.6, 7.4, 7.2, 
     : 7, 6.8, 6.6, 6.4, 6.2, 
     : 6, 5.8, 25, 24, 23, 
     : 22, 21, 20, 19, 18, 
     : 17, 16, 15, 14, 13, 
     : 12, 11.5, 11, 10.5, 10, 
     : 9.75, 9.5, 9.25, 9, 8.75, 
     : 8.5, 8.25, 8, 7.8, 7.6, 
     : 7.4, 7.2, 7, 6.8, 6.6, 
     : 6.4, 6.2, 25, 24, 23, 
     : 22, 21, 20, 19, 18, 
     : 17, 16, 15, 14, 13, 
     : 12, 11.5, 11, 10.5, 10, 
     : 9.75, 9.5, 9.25, 9, 8.75, 
     : 8.5, 8.25, 8, 7.8, 7.6, 
     : 7.4, 7.2, 7, 6.8, 6.6, 
     : 6.4, 6.2, 6, 5.8, 5.6/ 
     
      data thetasource1/
     : 0, 0, 0, 0, 0, 
     : 0, 0, 0, 0, 0, 
     : 0, 0, 0, 0, 0, 
     : 0, 0, 0, 0, 0, 
     : 0, 0, 0, 0, 0, 
     : 0, 0, 0, 0, 0, 
     : 0, 0, 0, 0, 0, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 180, 180, 180, 
     : 180, 180, 180, 180, 180, 
     : 180, 180, 180, 180, 180, 
     : 180, 180, 180, 180, 180, 
     : 180, 180, 180, 180, 180, 
     : 180, 180, 180, 180, 180, 
     : 180, 180, 180, 180, 180, 
     : 180, 180, 180, 180, 180/ 

	  data vstack1/
     : -27617347572827.4d0, 47342300751389.7d0, -20629553908091.3d0, 
     : -8805361168947.65d0, 6176313796357.37d0, 17489510638619.0d0, 
     : -29380548574969.3d0, 22859002790702.8d0, -16661318584941.1d0, 
     : 15319804276103.7d0, -12442981137032.4d0, 6455035862382.64d0, 
     : -1047838017155.24d0, -1956234475883.29d0, 2745373218463.40d0, 
     : -1044561493699.61d0, -621455469446.664d0, 4739043289201.54d0, 
     : -6769561853371.85d0, 8085621541257.92d0, -7590629721898.36d0, 
     : 5084484989064.87d0, -900800871724.023d0, 848309773880.437d0, 
     : -1045211883613.86d0, 2746192577199.87d0, -1443586632849.63d0, 
     : 55562204190.2812d0, 1651018970636.34d0, -727355878189.796d0, 
     : -2207244751737.72d0, 10633140220308.8d0, -11104946202404.1d0, 
     : -58812315758835.6d0, 57194816726962.9d0, 31176456221912.0d0, 
     : -48325184814535.1d0, 13457950383791.9d0, 13165088974690.8d0, 
     : 2388156071477.88d0, -36442255228828.5d0, 47935463026867.8d0, 
     : -34831155995223.8d0, 24798475918519.6d0, -22505332216030.8d0, 
     : 18169438615629.0d0, -9611590166359.85d0, 1937478684926.46d0, 
     : 2283844249367.81d0, -3474071353646.23d0, 1463945635640.13d0, 
     : 676223697591.549d0, -5974663491830.50d0, 8866544154075.75d0, 
     : -11055304648591.9d0, 10819382500062.3d0, -7338078369958.56d0, 
     : 1556633810604.73d0, -1217364432783.56d0, 1520433419956.80d0, 
     : -3695164013042.87d0, 1925943817607.74d0, 79313350900.5781d0, 
     : -2258095903568.52d0, 497567499766.708d0, 4967474599302.40d0, 
     : -21352068396156.1d0, 29143528981532.5d0, 65488317140320.9d0, 
     : -78868498029622.4d0, 6355242973810.65d0, 1835942252164.76d0, 
     : -14654156653577.8d0, 23761397606689.6d0, -7741521762481.28d0, 
     : -18576787571340.8d0, 32011473406663.4d0, -28105193709805.5d0, 
     : 17772067126612.3d0, -11863824414669.7d0, 9834073614322.41d0, 
     : -7589353443826.48d0, 4352025242657.48d0, -1556013593024.46d0, 
     : 136236923088.196d0, 432073055260.852d0, -440423468399.256d0, 
     : 152691911805.344d0, 994918429769.633d0, -2142186397825.20d0/
     
      data vstack2/
     : 3659287297879.56d0, -4326335584870.77d0, 3187536974673.72d0, 
     : -1083960844722.63d0, 467960693263.967d0, -498440188131.717d0, 
     : 1001736827627.74d0, -446920109168.890d0, -269147115341.119d0, 
     : 704282297270.027d0, 685314960137.544d0, -4706419290908.96d0, 
     : 17660925489694.9d0, -31074913409053.2d0, 25603571043229.0d0, 
     : -9185350161448.90d0, -257121628327.183d0, -9921363266893.18d0, 
     : 32645497428386.4d0, -40064246397670.2d0, 13818989572866.3d0, 
     : 16756992374515.0d0, -23676004529810.2d0, 17200952463739.2d0, 
     : -11613184178757.9d0, 7699169952851.52d0, -4464647443230.49d0, 
     : 2460941004169.29d0, -1599012888207.85d0, 1170034086004.05d0, 
     : -1220853026644.64d0, 1097186613898.66d0, -300058504589.504d0, 
     : -292131224350.515d0, 598294130451.457d0, -129081025786.498d0, 
     : -1126408846328.07d0, 1923710312964.87d0, -1632750851494.24d0, 
     : 635397137703.684d0, 90968790043.1426d0, -293365427554.903d0, 
     : 182001320233.994d0, -217047555524.782d0, 132381088095.067d0, 
     : -60259085332.4988d0, -828089691786.573d0, 2540496539645.35d0, 
     : -9107348817449.80d0, 14818194617451.8d0, 2295572721945.03d0, 
     : -10727994123899.1d0, -7953244948265.54d0, 9598089360453.57d0, 
     : -514883665681.167d0, 9852480548619.96d0, -61724041005614.7d0, 
     : 109583481302422.d0, -73473524794379.6d0, 1906294013413.07d0, 
     : 26523606087332.9d0, -25006216779161.9d0, 21777461956552.3d0, 
     : -15205455265504.1d0, 6549034207341.03d0, -1552507618242.10d0, 
     : 520697145226.721d0, -854193470609.261d0, 1963370789648.22d0, 
     : -2455751897269.74d0, 1560808026589.35d0, 22804821417.6868d0, 
     : -1167842021002.10d0, 1517962054836.86d0, 398834099462.195d0, 
     : -1136776592893.20d0, 578718838109.217d0, 1164862327710.49d0, 
     : -1583819074026.43d0, 1747460008692.87d0, -998996742462.680d0, 
     : 705910277819.172d0, 212786133470.566d0, -180596551360.467d0, 
     : 786247635818.000d0, 391173074154.066d0, -1961582880439.82d0, 
     : 16624477946829.9d0, -72008992170881.6d0, 50528829561461.9d0/
     
       data vstack3/
     : 19429044008269.4d0, -15626771375425.2d0, -14620407453715.9d0, 
     : 135425721303773.d0, -266490183489324.d0, 202813722536121.d0, 
     : -40214385435156.6d0, -39324844003649.8d0, 49398811366974.4d0, 
     : -46791295768903.1d0, 32914225525702.2d0, -14077970089636.6d0, 
     : 3090084387167.76d0, -269897882716.660d0, 572369403392.425d0, 
     : -2941482042164.55d0, 4255751923487.79d0, -3633707953806.12d0, 
     : 90724194405.9175d0, 2492122747644.76d0, -4785968929013.72d0, 
     : 1031768288765.91d0, -446461425311.249d0, 1605476866384.62d0, 
     : -5191654043732.15d0, 4463609553158.50d0, -4417120824872.68d0, 
     : 2245876608334.17d0, -1569943996810.65d0, -588794952428.078d0, 
     : 400200307163.740d0, -919930360329.023d0, -3369505301087.73d0, 
     : 14704008369849.8d0, -59310234232302.5d0, 194818511397795.d0, 
     : -139380037963832.d0, 9259623252240.90d0, -90644991027799.7d0, 
     : 180354629837132.d0, -139827939834682.d0, 31661067106142.6d0, 
     : 23339919721875.1d0, -32010391846621.9d0, 30819337530670.6d0, 
     : -21679834495429.7d0, 9344559429538.03d0, -2135581246618.59d0, 
     : 151911105651.459d0, -219893139433.090d0, 1733160456740.21d0, 
     : -2598858237159.74d0, 2394975933360.78d0, -28410850090.2026d0, 
     : -1677853050558.52d0, 3438317375185.83d0, -987992585527.121d0, 
     : 755744855376.293d0, -1482407032424.26d0, 3820413058373.46d0, 
     : -3068040937952.31d0, 2987936786984.89d0, -1479554670494.96d0, 
     : 1045706485856.67d0, 379265825633.895d0, -255992393151.901d0, 
     : 505328342930.617d0, 2386003765401.69d0, -10585316641036.6d0, 
     : 40926366439346.0d0, -131862812605731.d0, 95635189600595.7d0, 
     : -8803830124487.51d0, 6613456232912.07d0, 407875163992.672d0/
     
     
       DO JJ=1,90
       vcoef1(JJ)=vstack1(JJ)
       vcoef1(JJ+90)=vstack2(JJ)
      END DO
      DO JJ=1,75
       vcoef1(JJ+90*2)=vstack3(JJ)
      END DO
      N1=2
      M=5
      N2=2
      PI=DACOS(-1.D0)
      FACT=PI/180.D0
*      EVALUATE PES    
       SUMA=ZERO
       XTT=(1.d0-DCOS(TT*FACT))/2.d0 
       DO L=1,255
        TI=(1.d0-DCOS(thetasource1(L)*FACT))/2.d0
        ADD=vcoef1(L)*RKHS_DK(rsource1(L),RR,N1,M)*RKHS_AK(TI,XTT,N2)
        SUMA=SUMA+ADD
       END DO
       EVAL_PES_sum=SUMA
       RETURN
       END
*-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	
*PES EVALUATION CALL (DIF)
      FUNCTION EVAL_PES_dif(RR,TT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (NPT=204)
      dimension rsource2(204),thetasource2(204),vcoef2(204)
      dimension vstack1(90),vstack2(114)


      data rsource2/
     : 25, 24, 23, 22, 21, 
     : 20, 19, 18, 17, 16, 
     : 15, 14, 13, 12, 11.5, 
     : 11, 10.5, 10, 9.75, 9.5, 
     : 9.25, 9, 8.75, 8.5, 8.25, 
     : 8, 7.8, 7.6, 7.4, 7.2, 
     : 7, 6.8, 6.6, 6.4, 6.2, 
     : 6, 5.8, 5.6, 5.4, 5.2, 
     : 5, 25, 24, 23, 22, 
     : 21, 20, 19, 18, 17, 
     : 16, 15, 14, 13, 12, 
     : 11.5, 11, 10.5, 10, 9.75, 
     : 9.5, 9.25, 9, 8.75, 8.5, 
     : 8.25, 8, 7.8, 7.6, 7.4, 
     : 7.2, 7, 6.8, 6.6, 6.2, 
     : 6, 5.8, 5.6, 5.4, 5.2, 
     : 5, 25, 24, 23, 22, 
     : 21, 20, 19, 18, 17, 
     : 16, 15, 14, 13, 12, 
     : 11.5, 11, 10.5, 10, 9.75, 
     : 9.5, 9.25, 9, 8.75, 8.5, 
     : 8.25, 8, 7.8, 7.6, 7.4, 
     : 7.2, 7, 6.8, 6.6, 6.4, 
     : 6.2, 6, 5.8, 5.6, 5.4, 
     : 5.2, 5, 25, 24, 23, 
     : 22, 21, 20, 19, 18, 
     : 17, 16, 15, 14, 13, 
     : 12, 11.5, 11, 10.5, 10, 
     : 9.75, 9.5, 9.25, 9, 8.75, 
     : 8.5, 8.25, 8, 7.8, 7.6, 
     : 7.4, 7.2, 7, 6.8, 6.6, 
     : 6.4, 6.2, 6, 5.8, 5.6, 
     : 5.4, 5.2, 5, 25, 24, 
     : 23, 22, 21, 20, 19, 
     : 18, 17, 16, 15, 14, 
     : 13, 12, 11.5, 11, 10.5, 
     : 10, 9.75, 9.5, 9.25, 9, 
     : 8.75, 8.5, 8.25, 8, 7.8, 
     : 7.6, 7.4, 7.2, 7, 6.8, 
     : 6.6, 6.4, 6.2, 6, 5.8, 
     :5.6, 5.4, 5.2, 5/ 

	  data thetasource2/
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 30, 30, 30, 30, 
     : 30, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 60, 60, 60, 60, 
     : 60, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 90, 90, 90, 
     : 90, 90, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 120, 120, 
     : 120, 120, 120, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     : 150, 150, 150, 150, 150, 
     :150, 150, 150, 150/ 

	  data vstack1/
     : 217706943.242246d0, -324896325.011795d0, 24053968.7225969d0, 
     : 150789085.816722d0, -100480953.138870d0, 106188586.423509d0, 
     : -119285423.302960d0, 60407828.7454577d0, -2278732.05898624d0, 
     : -3173513.06865615d0, -11957069.8667616d0, 13528088.9720896d0, 
     : -4919681.18363392d0, -1475661.58564259d0, 5577748.89759826d0, 
     : -5150253.58059663d0, 268630.253612798d0, 12743860.3641273d0, 
     : -6097662.53848340d0, -9077193.54039170d0, 11473794.0621115d0, 
     : -7737635.44035535d0, 8964485.98645182d0, -90283.9441091232d0, 
     : -2778118.98236600d0, 1778729.16801410d0, 3015238.32953421d0, 
     : -3888666.71718817d0, 1966106.39283998d0, 158139.046758324d0, 
     : -5407240.92483867d0, 2392764.57846312d0, -10906731.4191315d0, 
     : -268724.305510860d0, -10065460.6259995d0, 3096.04477389157d0, 
     : 15294322.2532868d0, -10344806.6418265d0, 67354679.9094076d0, 
     : -186445204.645338d0, 128931347.228742d0, 1241633965.59128d0, 
     : -2424432992.92878d0, 1367040866.32071d0, 95894410.5514683d0, 
     : -623853044.996676d0, 777347140.040676d0, -670071082.363976d0, 
     : 298211275.861748d0, 25685816.0401604d0, -91974070.9076403d0, 
     : 16016413.0094268d0, 30672953.5778085d0, -22783470.6807616d0, 
     : 5579000.93018077d0, 18436700.3555045d0, -29952987.1809749d0, 
     : 19670414.6383047d0, 17349944.2969358d0, 18619800.6553182d0, 
     : -79685930.9937527d0, 95797683.3158184d0, -70036067.8220011d0, 
     : 57174989.0105996d0, -12101593.9349289d0, 768903.891304899d0, 
     : -3239677.10862674d0, 14171272.8090222d0, -5157079.28325401d0, 
     : -8303642.28216256d0, 11535296.0350453d0, -22241878.0582176d0, 
     : 6205596.61346564d0, -39865295.6611451d0, -55059469.3402812d0, 
     : -25537230.9129838d0, 40812386.6094996d0, -21185720.3351377d0, 
     : 146886610.843854d0, -391370888.017435d0, 316453962.718319d0, 
     : 1448220254.36433d0, -3492629063.37936d0, 3060276456.38009d0, 
     : -1235933502.84415d0, 132837301.881959d0, 378721114.012529d0, 
     : -470856528.573537d0, 158268685.652505d0, 141304536.412703d0/
     
     	  data vstack2/
     : -143375928.736919d0, -2300384.56154898d0, 68320188.6059026d0, 
     : -41394154.5460366d0, 1109386.17889261d0, 44331855.8464595d0, 
     : -62361758.3389041d0, 58044628.2722318d0, -57176299.1814201d0, 
     : 135577919.815480d0, -190177818.110736d0, 199105679.875857d0, 
     : -157646834.720983d0, 119894657.719532d0, -36775004.9504414d0, 
     : 14893474.4830840d0, -20484570.0688103d0, 37559262.3289469d0, 
     : -23348257.5546995d0, -2494427.95297310d0, 8394138.86059757d0, 
     : -25550837.1214980d0, -1197505.81390909d0, -48482169.0237926d0, 
     : -9391103.10256045d0, -67289033.7677699d0, -54655936.3943471d0, 
     : 54264886.2391280d0, -18877523.1279186d0, 148144934.884076d0, 
     : -379588346.205398d0, 343028436.710638d0, 384622568.719017d0, 
     : -1539731940.89310d0, 2083583681.76426d0, -1511155859.66575d0, 
     : 946200038.019221d0, -576660272.380302d0, 292991918.496658d0, 
     : -200628175.623573d0, 172476977.359764d0, -75383635.5516008d0, 
     : -32884659.4042299d0, 53382327.4412753d0, -14667296.7869482d0, 
     : -25522023.6295674d0, 54104032.4083953d0, -49441884.2470434d0, 
     : 43869137.6709153d0, -68640249.2704009d0, 134317162.909005d0, 
     : -151251792.548658d0, 151572157.854627d0, -132583403.469830d0, 
     : 102049971.141430d0, -35201146.3332972d0, 16618328.8443737d0, 
     : -24684433.8053636d0, 40946616.6057882d0, -33508631.5761606d0, 
     : 9396303.68506294d0, -1214445.69332834d0, -18946213.4987492d0, 
     : -1278565.93940989d0, -29227141.4455870d0, -10318547.6329315d0, 
     : -32906850.8080422d0, -29212204.1401435d0, 32670740.7245755d0, 
     : -12906703.4932918d0, 92729136.0317598d0, -242000516.923585d0, 
     : 217126669.851184d0, 10089692.0290130d0, -292536122.763358d0, 
     : 572406961.103457d0, -472550859.032990d0, 281041245.367995d0, 
     : -178132277.853232d0, 105044582.195993d0, -49998668.5183241d0, 
     : 21949017.3581854d0, -5833968.65871146d0, -7248720.35697280d0, 
     : 6341906.13126444d0, 2655851.73014939d0, -11077439.1791422d0, 
     : 15124227.3690562d0, -10422216.3176899d0, 8123964.93709069d0,
     : -14447069.1254767d0, 28569435.7508282d0, -29889843.5123225d0, 
     : 30975781.1999993d0, -30948234.8038736d0, 25833871.8429277d0, 
     : -11088201.8682643d0, 6962464.24992538d0, -9391548.41309595d0, 
     : 12405390.2938636d0, -8590394.44593177d0, -246544.872861473d0, 
     : 2458108.69651548d0, -7419605.42159117d0, 1283989.69338372d0, 
     : -4454628.18080693d0, -1524715.78710037d0, -6570760.36435304d0, 
     : -4232463.68664908d0, 4152109.45803330d0, -3608753.76293713d0, 
     : 16763616.7261671d0, -46690284.7180544d0, 44599092.2826702d0/
     
       DO JJ=1,90
       vcoef2(JJ)=vstack1(JJ)
      END DO
      DO JJ=1,114
       vcoef2(JJ+90)=vstack2(JJ)
      END DO
      
      N1=2
      M=5
      N2=6
      PI=DACOS(-1.D0)
      FACT=PI/180.D0
C      EVALUATE PES    
       SUMA=ZERO
       XTT=(DCOS(TT*FACT)) 
       DO L=1,NPT
        TI=DCOS(thetasource2(L)*FACT)
        ADD=vcoef2(L)*RKHS_DK(rsource2(L),RR,N1,M)*RKHS_OP(TI,XTT,N2,2)
        SUMA=SUMA+ADD
       END DO
       EVAL_PES_dif=SUMA
       RETURN
       END

*--------------------------------------------------------------------
* FUNCTIONS:
*
* RKHS_DK(X,Y,N,M): Reproducing kernel for  distance-like (DK) 
*                   variables, see Ho, Rabitz Eq(17) of
*                   J. Chem. Phys. 104, 2584 (1996) 
*                   Range = [0, inf]
*
*  INPUT: X,Y-DOUBLE PRECISION
*          N:INTEGER:ORDER OF SMOOTHNESS OF THE FUNCTION
*          M>=0:INTEGER:RECIPROCAL POWER OF THE WEIGHT W(X)=X**(-M)
*  OUTPUT: DOUBLE PRECISION
*_  _  _  _ 	_	_	_	_	_	_	_	_	_	_	_	_
* RKHS_AK(X,Y,N): Reproducing kernel for  angular-like (AK) 
*                   variables, see Ho, Rabitz Eq(23) of
*                   J. Chem. Phys. 104, 2584 (1996) 
*                    Range = [0, 1]
*    
*  INPUT: X,Y-DOUBLE PRECISION
*          N:INTEGER:ORDER OF SMOOTHNESS OF THE FUNCTION
*  OUPUT: DOUBLE PRECISION
*  HINT: SCALE ANGLES TO [0,1] INTEGRAL FOR ANGLES, FOR EXAMPLE: 
*          X=(1.d0-cosd(ANGLE))/2.d0
* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -            
* RKHS_OP(X,Y,N,M):Reproducing kernel for angular like 
*                    variables with a use of orthogonal 
*                    polynomials Plm(L,M,X) where X is 
*                    K=SUM_L=M^N PLM(X)PLM(X')
*                    variable transformed from angles as
*                    x=cos(theta)
*-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	
*RKHS_OP2L(X,Y,M,N)
*-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	
*Beta Function
*       Purpose: Compute the beta function B(p,q)
*       Input :  p  --- Parameter  ( p > 0 )
*                q  --- Parameter  ( q > 0 )
*       Output:  BT --- B(p,q)
*       Routine called: GAMMA for computing (x)
*-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	
*Hypergeometric Gauss Function
*       Purpose: Compute hypergeometric function F(a,b,c,x)
*       Input :  a --- Parameter
*                b --- Parameter
*                c --- Parameter, c <> 0,-1,-2,...
*                x --- Argument   ( x < 1 )
*       Output:  HF --- F(a,b,c,x)
*       Routines called:
*            (1) GAMMA for computing gamma function
*            (2) PSII for computing PSII function
*-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
*Legendre Polynomials (PLGNDR)
*-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
*Gamma Function
*       Purpose: Compute gamma function (x)
*       Input :  x  --- Argument of ( x )
*                       ( x is not equal to 0,-1,-2,...)
*       Output:  GA --- (x)
*-------------------------------------------------------------

*-------------------------------------------------------------
       DOUBLE PRECISION FUNCTION RKHS_DK(X,Y,N,M)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       IF (X .LT. Y) THEN
           XB=X
           XU=Y
       ELSE
           XB=Y
           XU=X
       ENDIF

       M=ABS(M)! FORCE M>=0
       NSQR=N*N
       XUPOWM=XU**(-(M+1))

*      TERM WITH BETA FUNCTION
       CALL BETA(DFLOAT(M+1),DFLOAT(N),BETATERM)

*      GET TERM WITH 2F1 HYPERGEOMETRIC  GAUSS FUNCTION
       CALL HYGFX(DFLOAT(-N+1),DFLOAT(M+1),DFLOAT(N+M+1),XB/XU,HF)
       RKHS_DK=NSQR*XUPOWM*BETATERM*HF
       RETURN
       END
*-------------------------------------------------------------
       DOUBLE PRECISION FUNCTION RKHS_AK(X,Y,N)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (ZERO=0.D0,ONE=1.D0)
       
       IF ((X.EQ.ZERO).OR.(Y.EQ.ZERO)) THEN
          RKHS_AK=ONE
          RETURN
       ENDIF
       IF (X .LT. Y) THEN
           XB=X
           XU=Y
       ELSE
           XB=Y
           XU=X
       ENDIF

       SUMA=ZERO
*      GET POLYNOMIAL TERM
       DO I=0,N-1
       SUMA=SUMA+(XU**I)*(XB**I)
       END DO

*      GET TERM WITH 2F1 HYPERGEOMETRIC  GAUSS FUNCTION
       CALL HYGFX(DFLOAT(1),DFLOAT(-N+1),DFLOAT(N+1),XB/XU,HF)
       
       RKHS_AK=SUMA+N*(XB**N)*(XU**(N-1))*HF
       RETURN
       END
*-------------------------------------------------------------
       DOUBLE PRECISION FUNCTION RKHS_OP(X,Y,N,M)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (ZERO=0.D0,ONE=1.D0)

       SUMA=ZERO
*      GET ORTHOGONAL POLYNOMIAL TERM
       DO I=ABS(M),N
       SUMA=SUMA+PLGNDR(I,M,X)*PLGNDR(I,M,Y)
       END DO
       RKHS_OP=SUMA
       RETURN
       END
*--------------------------------------------------------------
       DOUBLE PRECISION FUNCTION RKHS_OP2L(X,Y,N,M)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (ZERO=0.D0,ONE=1.D0)
 
       SUMA=ZERO
*      GET ORTHOGONAL POLYNOMIAL TERM
       DO I=ABS(M),N,2
       SUMA=SUMA+PLGNDR(I,M,X)*PLGNDR(I,M,Y)
       END DO
       RKHS_OP2L=SUMA
       RETURN
       END
*-------------------------------------------------------------
      FUNCTION PLGNDR(L,M,x)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      if(m.lt.0.or.m.gt.l.or.abs(x).gt.1.)pause
     *'bad arguments in plgndr'
      pmm=1.
      if(m.gt.0) then
        somx2=dsqrt((1.-x)*(1.+x))
        fact=1.
        do 11 i=1,m
          pmm=-pmm*fact*somx2
          fact=fact+2.
11      continue
      endif
      if(l.eq.m) then
        plgndr=pmm
      else
        pmmp1=x*(2*m+1)*pmm
        if(l.eq.m+1) then
          plgndr=pmmp1
        else
         do 12 ll=m+2,l
            pll=(x*(2*ll-1)*pmmp1-(ll+m-1)*pmm)/(ll-m)
            pmm=pmmp1
            pmmp1=pll
12        continue
          plgndr=pll
        endif
      endif
      return
      END
*-----------------------------------------------------------------------
        SUBROUTINE BETA(P,Q,BT)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        CALL GAMMA(P,GP)
        CALL GAMMA(Q,GQ)
        PPQ=P+Q
        CALL GAMMA(PPQ,GPQ)
        BT=GP*GQ/GPQ
        RETURN
        END
*-----------------------------------------------------------------------
        SUBROUTINE GAMMA(X,GA)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION G(26)
        PI=3.141592653589793D0
        IF (X.EQ.INT(X)) THEN
           IF (X.GT.0.0D0) THEN
              GA=1.0D0
              M1=X-1
              DO 10 K=2,M1
10               GA=GA*K
           ELSE
              GA=1.0D+300
           ENDIF
        ELSE
           IF (DABS(X).GT.1.0D0) THEN
              Z=DABS(X)
              M=INT(Z)
              R=1.0D0
              DO 15 K=1,M
15               R=R*(Z-K)
              Z=Z-M
           ELSE
              Z=X
           ENDIF
           DATA G/1.0D0,0.5772156649015329D0,
     &          -0.6558780715202538D0, -0.420026350340952D-1,
     &          0.1665386113822915D0,-.421977345555443D-1,
     &          -.96219715278770D-2, .72189432466630D-2,
     &          -.11651675918591D-2, -.2152416741149D-3,
     &          .1280502823882D-3, -.201348547807D-4,
     &          -.12504934821D-5, .11330272320D-5,
     &          -.2056338417D-6, .61160950D-8,
     &          .50020075D-8, -.11812746D-8,
     &          .1043427D-9, .77823D-11,
     &          -.36968D-11, .51D-12,
     &          -.206D-13, -.54D-14, .14D-14, .1D-15/
           GR=G(26)
           DO 20 K=25,1,-1
20            GR=GR*Z+G(K)
           GA=1.0D0/(GR*Z)
           IF (DABS(X).GT.1.0D0) THEN
              GA=GA*R
              IF (X.LT.0.0D0) GA=-PI/(X*GA*DSIN(PI*X))
           ENDIF
        ENDIF
        RETURN
        END
*----------------------------------------------------------------------
        SUBROUTINE HYGFX(A,B,C,X,HF)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        LOGICAL L0,L1,L2,L3,L4,L5
        PI=3.141592653589793D0
        EL=.5772156649015329D0
        L0=C.EQ.INT(C).AND.C.LT.0.0
        L1=1.0D0-X.LT.1.0D-15.AND.C-A-B.LE.0.0
        L2=A.EQ.INT(A).AND.A.LT.0.0
        L3=B.EQ.INT(B).AND.B.LT.0.0
        L4=C-A.EQ.INT(C-A).AND.C-A.LE.0.0
        L5=C-B.EQ.INT(C-B).AND.C-B.LE.0.0
        IF (L0.OR.L1) THEN
           WRITE(*,*)'The hypergeometric series is divergent'
           RETURN
        ENDIF
        EPS=1.0D-15
        IF (X.GT.0.95) EPS=1.0D-8
        IF (X.EQ.0.0.OR.A.EQ.0.0.OR.B.EQ.0.0) THEN
           HF=1.0D0
           RETURN
        ELSE IF (1.0D0-X.EQ.EPS.AND.C-A-B.GT.0.0) THEN
           CALL GAMMA(C,GC)
           CALL GAMMA(C-A-B,GCAB)
           CALL GAMMA(C-A,GCA)
           CALL GAMMA(C-B,GCB)
           HF=GC*GCAB/(GCA*GCB)
           RETURN
        ELSE IF (1.0D0+X.LE.EPS.AND.DABS(C-A+B-1.0).LE.EPS) THEN
           G0=DSQRT(PI)*2.0D0**(-A)
           CALL GAMMA(C,G1)
           CALL GAMMA(1.0D0+A/2.0-B,G2)
           CALL GAMMA(0.5D0+0.5*A,G3)
           HF=G0*G1/(G2*G3)
           RETURN
        ELSE IF (L2.OR.L3) THEN
           IF (L2) NM=INT(ABS(A))
           IF (L3) NM=INT(ABS(B))
           HF=1.0D0
           R=1.0D0
           DO 10 K=1,NM
              R=R*(A+K-1.0D0)*(B+K-1.0D0)/(K*(C+K-1.0D0))*X
10            HF=HF+R
           RETURN
        ELSE IF (L4.OR.L5) THEN
           IF (L4) NM=INT(ABS(C-A))
           IF (L5) NM=INT(ABS(C-B))
           HF=1.0D0
           R=1.0D0
           DO 15 K=1,NM
              R=R*(C-A+K-1.0D0)*(C-B+K-1.0D0)/(K*(C+K-1.0D0))*X
15            HF=HF+R
           HF=(1.0D0-X)**(C-A-B)*HF
           RETURN
        ENDIF
        AA=A
        BB=B
        X1=X
        IF (X.LT.0.0D0) THEN
           X=X/(X-1.0D0)
           IF (C.GT.A.AND.B.LT.A.AND.B.GT.0.0) THEN
              A=BB
              B=AA
           ENDIF
           B=C-B
        ENDIF
        IF (X.GE.0.75D0) THEN
           GM=0.0D0
           IF (DABS(C-A-B-INT(C-A-B)).LT.1.0D-15) THEN
              M=INT(C-A-B)
              CALL GAMMA(A,GA)
              CALL GAMMA(B,GB)
              CALL GAMMA(C,GC)
              CALL GAMMA(A+M,GAM)
              CALL GAMMA(B+M,GBM)
              CALL PSII(A,PA)
              CALL PSII(B,PB)
              IF (M.NE.0) GM=1.0D0
              DO 30 J=1,ABS(M)-1
30               GM=GM*J
              RM=1.0D0
              DO 35 J=1,ABS(M)
35               RM=RM*J
              F0=1.0D0
              R0=1.0D0
              R1=1.0D0
              SP0=0.D0
              SP=0.0D0
              IF (M.GE.0) THEN
                 C0=GM*GC/(GAM*GBM)
                 C1=-GC*(X-1.0D0)**M/(GA*GB*RM)
                 DO 40 K=1,M-1
                    R0=R0*(A+K-1.0D0)*(B+K-1.0)/(K*(K-M))*(1.0-X)
40                  F0=F0+R0
                 DO 45 K=1,M
45                  SP0=SP0+1.0D0/(A+K-1.0)+1.0/(B+K-1.0)-1.0/K
                 F1=PA+PB+SP0+2.0D0*EL+DLOG(1.0D0-X)
                 DO 55 K=1,250
                    SP=SP+(1.0D0-A)/(K*(A+K-1.0))+(1.0-B)/(K*(B+K-1.0))
                    SM=0.0D0
                    DO 50 J=1,M
50                     SM=SM+(1.0D0-A)/((J+K)*(A+J+K-1.0))+1.0/
     &                    (B+J+K-1.0)
                    RP=PA+PB+2.0D0*EL+SP+SM+DLOG(1.0D0-X)
                    R1=R1*(A+M+K-1.0D0)*(B+M+K-1.0)/(K*(M+K))*(1.0-X)
                    F1=F1+R1*RP
                    IF (DABS(F1-HW).LT.DABS(F1)*EPS) GO TO 60
55                  HW=F1
60               HF=F0*C0+F1*C1
              ELSE IF (M.LT.0) THEN
                 M=-M
                 C0=GM*GC/(GA*GB*(1.0D0-X)**M)
                 C1=-(-1)**M*GC/(GAM*GBM*RM)
                 DO 65 K=1,M-1
                    R0=R0*(A-M+K-1.0D0)*(B-M+K-1.0)/(K*(K-M))*(1.0-X)
65                  F0=F0+R0
                 DO 70 K=1,M
70                  SP0=SP0+1.0D0/K
                 F1=PA+PB-SP0+2.0D0*EL+DLOG(1.0D0-X)
                 DO 80 K=1,250
                    SP=SP+(1.0D0-A)/(K*(A+K-1.0))+(1.0-B)/(K*(B+K-1.0))
                    SM=0.0D0
                    DO 75 J=1,M
75                     SM=SM+1.0D0/(J+K)
                    RP=PA+PB+2.0D0*EL+SP-SM+DLOG(1.0D0-X)
                    R1=R1*(A+K-1.0D0)*(B+K-1.0)/(K*(M+K))*(1.0-X)
                    F1=F1+R1*RP
                    IF (DABS(F1-HW).LT.DABS(F1)*EPS) GO TO 85
80                  HW=F1
85               HF=F0*C0+F1*C1
              ENDIF
           ELSE
              CALL GAMMA(A,GA)
              CALL GAMMA(B,GB)
              CALL GAMMA(C,GC)
              CALL GAMMA(C-A,GCA)
              CALL GAMMA(C-B,GCB)
              CALL GAMMA(C-A-B,GCAB)
              CALL GAMMA(A+B-C,GABC)
              C0=GC*GCAB/(GCA*GCB)
              C1=GC*GABC/(GA*GB)*(1.0D0-X)**(C-A-B)
              HF=0.0D0
              R0=C0
              R1=C1
              DO 90 K=1,250
                 R0=R0*(A+K-1.0D0)*(B+K-1.0)/(K*(A+B-C+K))*(1.0-X)
                 R1=R1*(C-A+K-1.0D0)*(C-B+K-1.0)/(K*(C-A-B+K))
     &              *(1.0-X)
                 HF=HF+R0+R1
                 IF (DABS(HF-HW).LT.DABS(HF)*EPS) GO TO 95
90               HW=HF
95            HF=HF+C0+C1
           ENDIF
        ELSE
           A0=1.0D0
           IF (C.GT.A.AND.C.LT.2.0D0*A.AND.
     &         C.GT.B.AND.C.LT.2.0D0*B) THEN
              A0=(1.0D0-X)**(C-A-B)
              A=C-A
              B=C-B
           ENDIF
           HF=1.0D0
           R=1.0D0
           DO 100 K=1,250
              R=R*(A+K-1.0D0)*(B+K-1.0D0)/(K*(C+K-1.0D0))*X
              HF=HF+R
              IF (DABS(HF-HW).LE.DABS(HF)*EPS) GO TO 105
100           HW=HF
105        HF=A0*HF
        ENDIF
        IF (X1.LT.0.0D0) THEN
           X=X1
           C0=1.0D0/(1.0D0-X)**AA
           HF=C0*HF
        ENDIF
        A=AA
        B=BB
        IF (K.GT.120) WRITE(*,115)
115     FORMAT(1X,'Warning! You should check the accuracy')
        RETURN
        END



        SUBROUTINE PSII(X,PS)
C
C       ======================================
C       Purpose: Compute PSII function
C       Input :  x  --- Argument of PSII(x)
C       Output:  PS --- PSII(x)
C       ======================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        XA=DABS(X)
        PI=3.141592653589793D0
        EL=.5772156649015329D0
        S=0.0D0
        IF (X.EQ.INT(X).AND.X.LE.0.0) THEN
           PS=1.0D+300
           RETURN
        ELSE IF (XA.EQ.INT(XA)) THEN
           N=XA
           DO 10 K=1 ,N-1
10            S=S+1.0D0/K
           PS=-EL+S
        ELSE IF (XA+.5.EQ.INT(XA+.5)) THEN
           N=XA-.5
           DO 20 K=1,N
20            S=S+1.0/(2.0D0*K-1.0D0)
           PS=-EL+2.0D0*S-1.386294361119891D0
        ELSE
           IF (XA.LT.10.0) THEN
              N=10-INT(XA)
              DO 30 K=0,N-1
30               S=S+1.0D0/(XA+K)
              XA=XA+N
           ENDIF
           X2=1.0D0/(XA*XA)
           A1=-.8333333333333D-01
           A2=.83333333333333333D-02
           A3=-.39682539682539683D-02
           A4=.41666666666666667D-02
           A5=-.75757575757575758D-02
           A6=.21092796092796093D-01
           A7=-.83333333333333333D-01
           A8=.4432598039215686D0
           PS=DLOG(XA)-.5D0/XA+X2*(((((((A8*X2+A7)*X2+
     &        A6)*X2+A5)*X2+A4)*X2+A3)*X2+A2)*X2+A1)
           PS=PS-S
        ENDIF
        IF (X.LT.0.0) PS=PS-PI*DCOS(PI*X)/DSIN(PI*X)-1.0D0/X
        RETURN
        END
*------------------------------------------------------------------------------

