      subroutine driver
      implicit double precision (a-h,o-z)
      common /cosysr/ xjunk(2),rshift,xfact
      common /covvl/ vvl(10)
      include "common/parpot"
      potnam='HeCO Moszynski et al. SAPT PES'
      print *, potnam
1      print *, ' r (bohr)'
      rshift=0.5
      xfact=0.8
      read (5, *, end=99) r
      call pot(vv0,r)
      write (6, 100) vv0,vvl
100   format(' vsum',/,7(1pe16.8))
      goto 1
99    end

      include "common/syusr"
      include "common/bausr"
      include "common/ground"
      subroutine loapot(iunit,filnam)
* ------------------------------------------------------------------------
      character*(*) filnam
      include "common/parbas"
      include "common/parpot"
      potnam='HeCO Moszynski et al. SAPT PES'
      lammin(1)=1
      lammax(1)=10
      mproj(1)=0
      ntv(1)=1
      ivcol(1,1)=0
      ivrow(1,1)=0
      return
      end
* ----------------------------------------------------------------------
      subroutine pot (vv0, r)
*  subroutine to calculate the r-dependent coefficients
*  in atomic units (distance and energy)
* ----------------------------------------------------------------------
*  on entry:
*    r:      interparticle distance
*  on return:
*  vv0        contains isotropic term (d00 term in vsum)
*  variable in common block /covvl/
*    vvl:     vector of length 6 to store r-dependence of each term
*             in potential expansion
*    vvl(1-10) expansion coefficients in dl0 (l=1:11) of vsum

* uses linear least squares routines from cmlib

* author:  millard alexander
* latest revision date:  8-oct-1993
* revised for He-NO(X) : 1-20-95 by Moonbong Yang
* revised for CCSD(T) PES: 2002.10.13 by Jacek Klos
*revised for Ar-OH(A^2Sigma+) 2005 J.Klos
* ----------------------------------------------------------------------

      implicit double precision (a-h,o-z)
      dimension xlam1(7),xlam2(7),r0(7),
     :          vsum(11),xsum(11),
     :          d0(121),aa(121),thta(11),cthta(11)
      dimension kpvt(11),qraux(11),work(121),rsd(11),re(14)

      common /covvl/ vvl(10)
      data half, zero, one, alph /0.5d0, 0.d0, 1.d0, 1.2d0/
* for distances beyond rmax difference potential is damped
      data rmax /13d0/
* coefficicients for d0 rotation matrices
* stored (by column) for each of 7 angles and for l=0:6
* angles are 0 20 40 60 80 90 100 120 140 160 180
      data d0/
     :  1.d0,!l=0
     :  1.d0,
     :  1.d0,
     :  1.d0,
     :  1.d0,
     :  1.d0,
     :  1.d0,
     :  1.d0,
     :  1.d0,
     :  1.d0,
     :  1.d0,!l=0
     :                    1.d0, !l=1
     :    0.939692620785908d0,
     :    0.766044443118978d0,
     :                  0.5d0,
     :     0.17364817766693d0,
     :                  1d-16,
     :    -0.17364817766693d0,
     :                 -0.5d0,
     :   -0.766044443118978d0,
     :   -0.939692620785908d0,
     :                   -1d0, !l=1
     :                    1d0, !l=2
     :    0.824533332339233d0, 
     :    0.380236133250197d0,
     :               -0.125d0,
     :   -0.454769465589431d0,
     :                 -0.5d0,
     :   -0.454769465589431d0,
     :               -0.125d0,
     :    0.380236133250197d0,
     :    0.824533332339233d0,
     :                    1d0, !l=2
     :                    1d0, !l=3
     :    0.664884732794716d0, 
     :  -0.0252333338303835d0,
     :              -0.4375d0,
     :   -0.247381933374901d0,
     :                  1d-16,
     :    0.247381933374901d0,
     :               0.4375d0,
     :   0.0252333338303835d0,
     :   -0.664884732794716d0,
     :                   -1d0, !l=3
     : 1d0,                   !l=4
     :    0.474977735636283d0,
     :   -0.319004346471378d0,
     :           -0.2890625d0,
     :    0.265901610835095d0,
     :                0.375d0,
     :    0.265901610835095d0,
     :           -0.2890625d0,
     :   -0.319004346471378d0,
     :    0.474977735636283d0,
     :                    1d0,!l=4
     :  1.d0,                 !l=5
     :    0.271491745551255d0,
     :   -0.419682045437054d0,
     :           0.08984375d0,
     :    0.281017540988309d0,
     :                  1d-16,
     :   -0.281017540988309d0,
     :          -0.08984375d0,
     :    0.419682045437054d0,
     :   -0.271491745551255d0,
     :                   -1d0,!l=5
     :                   1.d0,!l=6
     :   0.0719030017842305d0,
     :   -0.323570725710931d0,
     :         0.3232421875d0,
     :   -0.132121338573299d0,
     :              -0.3125d0,
     :   -0.132121338573299d0,
     :         0.3232421875d0,
     :   -0.323570725710931d0,
     :   0.0719030017842305d0,
     :                    1d0, !l=6
     :                    1d0, !l=7
     :   -0.107226158692938d0,
     :   -0.100601708629502d0,
     :        0.22314453125d0,
     :   -0.283479918813435d0,
     :                  1d-16,
     :    0.283479918813435d0,
     :       -0.22314453125d0,
     :    0.100601708629502d0,
     :    0.107226158692938d0,
     :                   -1d0,!l=7
     :                    1d0,!l=8
     :   -0.251839432959275d0,
     :    0.138626797752243d0,
     :   -0.073638916015625d0,
     :   0.0233078500507821d0,
     :            0.2734375d0,
     :   0.0233078500507821d0,
     :   -0.073638916015625d0,
     :    0.138626797752243d0,
     :   -0.251839432959275d0,
     :                    1d0,!l=8
     :                    1d0, !l=9
     :   -0.351696543958561d0,
     :    0.290012951832139d0,
     :   -0.267898559570312d0,
     :    0.259627174131175d0,
     :                  1d-16,
     :   -0.259627174131175d0,
     :    0.267898559570312d0,
     :   -0.290012951832139d0,
     :    0.351696543958561d0,
     :                   -1d0, !l=9
     :                    1d0, !l=10
     :   -0.401269139852809d0,
     :    0.297345221371711d0,
     :   -0.188228607177734d0,
     :   0.0646821277096134d0,
     :          -0.24609375d0,
     :   0.0646821277096134d0,
     :   -0.188228607177734d0,
     :    0.297345221371711d0,
     :   -0.401269139852809d0,
     :                    1d0/!l=10
      thta(1)=0.D0
      thta(2)=20.D0
      thta(3)=40.D0
      thta(4)=60.D0
      thta(5)=80.D0
      thta(6)=90.D0
      thta(7)=100.D0
      thta(8)=120.D0
      thta(9)=140.D0
      thta(10)=160.D0
      thta(11)=180.D0
      do i=1,11
      cthta(i)=dcos(thta(i)*dacos(-1.D0)/180.D0)
      enddo
      RCO=2.132d0
      do 100 i=1,11
        vsum(i)=hecopot(r,RCO,cthta(i))
100   continue
* solve simultaneous equations for solutions
      tol=1.e-10
      call dcopy(121,d0,1,aa,1)
      call dqrank(aa,11,11,11,tol,kr,kpvt,qraux,work)
      call dqrlss(aa,11,11,11,kr,vsum,xsum,rsd,kpvt,qraux)
* convert to hartree
C      conv=1.d0/219474.6
c      call dscal(11,conv,xsum,1)
      vv0=xsum(1)
      call dcopy(10,xsum(2),1,vvl,1)
      end
C------PES---------

*===============================================================================
      REAL*8 FUNCTION HECOPOT (RDIM, RCO, XCOS)
*-------------------------------------------------------------------------------
*
*  Function returns the ab initio SAPT potential energy of the He--CO complex.
*  The configuration of the system is specified by the Jacobi coordinates 
*  RDIM [distance between atom and molecular c.o.m.], RCO [CO bond length],
*  and XCOS [= cos(THETA)].
*  Energies are in Hartree, distances are in bohr.
*
*  Analytical fit by R. Moszynski, September 1996.
*  Update of the Fortran code by T.G.A. Heijmen, May 1997.
*
*-------------------------------------------------------------------------------
      IMPLICIT REAL*8 (a-h,o-z)
      PARAMETER ( re=2.132d0, logmax=12 )
      DIMENSION xi(0:3), pleg(0:10), dlfac(0:logmax)
      COMMON /param/ ael(0:10,0:3), bel(0:10,0:3), alel(0:10),
     $               aex(0:8,0:3),  bex(0:8,0:3), alex(0:8),
     $               ad(0:8,0:3),  bd(0:8), bdd(0:8), cd(6:12,0:6,0:3),
     $               ai(0:10,0:3), bi(0:8), ci(6:12,0:6,0:3)
      LOGICAL first
      DATA first /.true./
      SAVE

c... Fill array DLFAC with log(n!)
      IF (first) THEN
        CALL filfac(dlfac, logmax)
        first = .false.
      ENDIF

C.. Deviation of CO bond length from equilibrium
      xi(0) = 1.d0
      xi(1) = rco - re
      DO k=2,3
        xi(k) = xi(k-1) * xi(1)
      ENDDO

C.. Fill array PLEG with Legendre polynomials P(l,xcos)
      CALL polleg(pleg, 10, xcos)

C.. Electrostatics
      aael = 0.d0
      bbel = 0.d0
      alphael = 0.d0
      DO l=0,10
        DO k=0,3
          aael = aael + ael(l,k) * pleg(l) * xi(k)
          bbel = bbel + bel(l,k) * pleg(l) * xi(k)
        ENDDO ! k
        alphael = alphael + alel(l) * pleg(l)
      ENDDO ! l
      elst = ( aael + bbel*rdim ) * exp( -alphael*rdim )

C.. Exchange
      alphaex = 0.d0
      aaex = 0.d0
      bbex = 0.d0
      DO l=0,8
        alphaex = alphaex + alex(l) * pleg(l)
        DO k=0,3
          aaex = aaex + aex(l,k) * pleg(l) * xi(k)
          bbex = bbex + bex(l,k) * pleg(l) * xi(k)
        ENDDO ! k
      ENDDO ! l
      exch = ( aaex + bbex*rdim ) * exp( -alphaex*rdim )

C.. Dispersion (short-range component)
      aad = 0.d0
      betad = 0.d0
      betadd = 0.d0
      DO l=0,8
        DO k=0,3
          aad = aad + ad(l,k) * pleg(l) * xi(k)
        ENDDO ! k
        betad = betad + bd(l) * pleg(l)
        betadd = betadd + bdd(l) * pleg(l)
      ENDDO ! l
      disp = aad * exp(-betad * rdim)

C.. Induction (short-range component)
      aai = 0.d0
      betai = 0.d0
      DO l=0,10
        DO k=0,3
          aai = aai + ai(l,k) * pleg(l) * xi(k)
        ENDDO ! k
      ENDDO ! l
      DO l=0,8
        betai = betai + bi(l) * pleg(l)
      ENDDO ! l
      xind = aai * exp(-betai * rdim)

C.. Long-range contributions to dispersion and induction energies
      rn = rdim**(-5)
      DO n=6,12
        cdn = 0.d0
        cin = 0.d0
        rn = rn / rdim
        DO l=mod(n,2),min(n-4,6),2
          DO k=0,3
            cdn = cdn + cd(n,l,k) * pleg(l) * xi(k)
            cin = cin + ci(n,l,k) * pleg(l) * xi(k)
          ENDDO ! k
        ENDDO ! l
        disp = disp + cdn * fdamp(n, rdim, betadd, dlfac, logmax) * rn
        xind = xind + cin * fdamp(n, rdim, betai, dlfac, logmax) * rn
      ENDDO ! n

C.. Sum the contributions
      hecopot = elst + exch + xind + disp
C     hecopot = hecopot * 219474.6307d0 ! conversion to cm-1

      END
*-------------------------------------------------------------------------------
      BLOCK DATA
*-------------------------------------------------------------------------------
      IMPLICIT REAL*8 (a-h,o-z)
      COMMON /param/ ael(0:10,0:3), bel(0:10,0:3), alel(0:10),
     $               aex(0:8,0:3), bex(0:8,0:3), alex(0:8),
     $               ad(0:8,0:3), bd(0:8), bdd(0:8), cd(6:12,0:6,0:3),
     $               ai(0:10,0:3), bi(0:8), ci(6:12,0:6,0:3)

C--Electrostatic energy
      DATA ael / -1.422150074D+01, -8.113611894D+01,  4.098642011D+00,
     $           -3.909194778D+01,  4.285694244D+00,  1.789254423D+00,
     $            6.384209612D-01,  2.600604469D+00, -1.593748989D+00,
     $            9.946409878D-01,  1.995676441D-01,
     $           -3.750862636D+00,  6.274075702D+01, -6.881469652D+00,
     $            3.383640008D+01,  4.479472324D-01,  3.735383535D+00,
     $           -6.553060767D+00,  2.375716427D-01, -5.613142927D+00,
     $            2.716267536D+00,  9.039472910D-02,
     $            3.806821860D+01,  4.776459727D+01,  2.745587928D+01,
     $            4.628163027D+01, -1.062485746D+01,  8.322695219D+00,
     $           -5.174757095D+00,  4.466351875D+00, -1.416176502D+01,
     $            3.540704425D+00,  1.197462685D+01,
     $            2.125840902D+01, -1.838526932D+01,  1.111500692D+01,
     $            3.708575359D+00,  9.875933340D+00,  9.946059532D+00,
     $           -5.399378800D+00,  2.461378977D+01, -3.863862397D+01,
     $            1.104028201D+01,  6.350539295D+01/
      DATA bel / -1.525144294D+01,  2.189734856D+01, -3.940969007D+01,
     $            9.550777405D+00, -1.581730033D+01, -5.369498028D-01,
     $           -3.116645538D+00, -4.408545844D-01,  1.221185602D+00,
     $           -4.100215689D-01, -5.861465278D-01,                  
     $           -1.106111500D+01, -1.665340670D+01, -3.166329430D+01,
     $           -4.685731615D+00, -1.924185118D+01,  1.466660946D+00,
     $           -3.346012388D+00,  5.557066250D-01,  9.379975431D-01,
     $           -6.751186507D-01, -2.906711383D-01,                  
     $           -1.198937620D+01, -1.304290495D+01, -1.891718111D+01,
     $           -1.060980485D+01, -8.276449356D+00,  6.656549311D-02,
     $           -2.927879128D+00,  4.369790170D-02,  2.246666547D+00,
     $           -5.828377975D-01, -2.557256393D+00,                  
     $           -5.272647817D+00,  3.538637918D+00, -5.468446373D+00,
     $           -4.833929080D-01, -4.515788416D+00, -1.031221319D+00,
     $           -3.591392398D-01, -4.189280807D+00,  7.181191547D+00,
     $           -1.999557096D+00, -1.269547078D+01/
      DATA alel/  2.192189185D+00,  1.063851301D-01,  1.324275408D-01,
     $            4.489446452D-02, -1.346001914D-02, -1.441357334D-02,
     $            3.261787106D-02, -8.308586911D-04, -5.742647714D-02,
     $            1.894947882D-03,  2.655747088D-02/

C--Exchange energy
      DATA aex /  2.193469114D+01,  2.910571808D+02, -1.230436992D+00,
     $            1.022904584D+02,  4.169236610D+01,  2.802621910D+00,
     $            4.764540321D+01, -3.749235807D+01,  1.393850275D+01,
     $            4.522251381D+01, -2.501388947D+01,  2.032504941D+02,
     $            1.130755851D+01,  5.990772789D+01, -4.129180045D+01,
     $            7.197878522D+01, -2.402123733D+01,  1.940306621D+01,
     $           -9.588646222D+01,  7.588878575D+01,  7.823302906D+01,
     $           -4.146491020D+01,  4.734945316D+01, -2.737404023D+01,
     $            6.995798610D+01, -4.398839048D+01,  2.919675686D+01,
     $           -6.251382976D+01,  1.158075503D+02, -8.066734767D+01,
     $            3.074482299D+01,  8.722885778D+00, -1.297761147D+01,
     $            2.986285602D+01, -3.047256277D+01,  2.957892106D+01/
      DATA bex /  4.570413991D+01, -1.172778496D+02,  7.601512390D+01,
     $           -5.228258837D+01,  2.210020478D+01, -6.064856369D+00,
     $           -9.153866151D+00,  9.407794857D+00, -3.316015814D+00,
     $            1.565784049D+01, -2.105309561D+01,  2.124716124D+01,
     $           -3.986667365D+01,  2.737518369D+01, -4.422177305D+00,
     $           -6.586933867D+00,  2.822875470D+00, -3.457190361D+00,
     $            2.710399231D+01, -2.531261892D+01,  6.343112683D+00,
     $           -3.471788168D+00,  1.016326583D+01, -5.761679528D+00,
     $           -5.603806390D+00,  5.890266126D+00, -4.002267518D+00,
     $            1.534933930D+01, -3.010497605D+01,  2.169417497D+01,
     $           -9.460429690D+00,  2.223345839D+00, -1.279521473D+00,
     $           -2.566533773D+00,  4.078157469D+00, -4.211145625D+00/
      DATA alex/  2.093526578D+00, -3.824816296D-02, -3.718543811D-02,
     $            3.971797035D-02,  6.333725788D-02,  4.084550947D-03,
     $           -3.195372742D-02, -1.838021762D-03,  5.810388188D-03/

C--Dispersion energy
      DATA ad /  -2.386339070D+00, -3.032199829D-01, -2.371493136D+00,
     $            4.080264389D-01, -5.789868957D-01,  1.836560139D-01,
     $           -8.592822518D-02, -2.836949832D-02, -1.100291257D-01,
     $           -1.108079179D+00, -6.415663400D-01, -1.960450192D+00,
     $            2.436676543D-01, -6.492876897D-01,  2.551081501D-01,
     $           -1.744326136D-01, -2.842027553D-02, -8.627090151D-02,
     $           -3.541934886D-01,  2.295530226D-01, -1.222351141D+00,
     $            6.970157283D-01,  1.716493755D-01, -2.783338731D+00,
     $            5.780661330D-01,  2.190863785D+00, -9.416210920D-01,
     $           -3.388494010D-01,  1.294827967D+00, -1.958311593D+00,
     $            3.271068583D+00,  2.189358632D+00, -1.163779598D+01,
     $            2.690959252D+00,  8.729380951D+00, -3.576097176D+00/
      DATA bd /   1.547970309D+00,  1.856568345D-01, -3.607900868D-02,
     $           -6.377735532D-02,  3.994100379D-02,  7.685435716D-03,
     $           -1.574479951D-02,  2.635401640D-03,  6.971358777D-03/
      DATA bdd /  1.479139111D+00,  3.248676448D-01, -1.172032579D-01,
     $           -9.052665701D-02,  9.045032554D-02,  1.502017036D-02,
     $           -3.950339016D-02, -1.036799753D-03,  1.362416006D-02/

C--Induction energy
      DATA ai /  -1.213222085D+02, -7.723214191D+01, -2.518672006D+02,
     $           -6.652210583D+01, -1.209231749D+02, -4.716438734D+01,
     $           -4.595527257D+01, -2.241708805D+01, -1.392259492D+01,
     $           -9.738891868D+00, -4.426371578D+00,
     $           -1.097067889D+02, -1.141601482D+02, -3.059607528D+02,
     $           -9.523719164D+01, -1.885023056D+02, -5.922373299D+01,
     $           -7.753578134D+01, -3.491041785D+01, -2.711222034D+01,
     $           -1.783762895D+01, -8.252757477D+00,
     $           -7.524438820D+01, -9.152875027D+01, -2.132697032D+02,
     $           -9.104641121D+01, -1.589654926D+02, -5.073740445D+01,
     $           -7.403703011D+01, -2.976404558D+01, -2.902676284D+01,
     $           -1.802009795D+01, -8.973870200D+00,
     $           -3.139555666D+01, -4.094323100D+01, -1.021995990D+02,
     $           -4.466585855D+01, -7.800306122D+01, -2.319257580D+01,
     $           -4.037423831D+01, -1.489538742D+01, -1.762769008D+01,
     $           -9.332195404D+00, -5.299965506D+00/
      DATA bi /   2.409837467D+00,  2.298384968D-01,  7.225805817D-02,
     $           -2.014725761D-02,  1.920183507D-02,  3.634996627D-02,
     $            1.023122438D-02, -4.822596864D-03, -2.418297929D-03/

C--Long range dispersion coefficients
      DATA cd /  -1.082869054D+01, 0.D+00, -2.544933386D+02, 0.D+00,  ! l=0, k=0
     $           -5.682601022D+03, 0.D+00, -5.519872477D+04,
     $            0.D+00,  2.820276291D+01, 0.D+00,  1.229077289D+03, ! l=1
     $            0.D+00,  3.533696995D+04, 0.D+00,
     $           -1.276921202D+00, 0.D+00, -2.717994770D+02, 0.D+00,  ! l=2
     $           -9.975314208D+03, 0.D+00, -1.040533212D+05,
     $            0.D+00, -1.082303500D+00, 0.D+00, 6.290134020D+02,  ! l=3
     $            0.D+00,  2.861562638D+04, 0.D+00,
     $            0.D+00, 0.D+00, 1.047517133D+01, 0.D+00,            ! l=4
     $           -2.067893798D+03, 0.D+00, -2.328174525D+04,
     $            0.D+00, 0.D+00, 0.D+00, -3.000437654D+01,           ! l=5
     $            0.D+00, 4.397860625D+03, 0.D+00,
     $            4*0.D+00, 1.060373807D+02, 0.D+00, 7.652976787D+02, ! l=6
     $           -4.790599969D+00, 0.D+00, -9.223687096D+01, 0.D+00,  ! l=0, k=1
     $           -2.630941125D+03, 0.D+00, -2.853155783D+04,
     $            0.D+00, -1.623651223D+00, 0.D+00, 1.497001596D+02,  ! l=1
     $            0.D+00,  1.137431652D+04, 0.D+00,
     $           -2.770557501D+00, 0.D+00, -1.536490510D+02, 0.D+00,  ! l=2
     $           -6.004409738D+03, 0.D+00, -6.469059521D+04,
     $            0.D+00, 2.783700032D+00, 0.D+00, 4.894832849D+02,   ! l=3
     $            0.D+00, 2.236823170D+04, 0.D+00,
     $            0.D+00, 0.D+00, -7.900727617D+00, 0.D+00,           ! l=4
     $           -2.528582648D+03, 0.D+00, -2.733795078D+04,
     $            0.D+00, 0.D+00, 0.D+00, -9.976853019D+00,           ! l=5
     $            0.D+00, 8.246118663D+03, 0.D+00,
     $            4*0.D+00, 1.085983993D+02, 0.D+00, 7.780377042D+02, ! l=6
     $           -2.812347233D+00, 0.D+00,-3.582162551D+01, 0.D+00,   ! l=0, k=2
     $           -1.095232589D+03, 0.D+00,-1.254547786D+04,                
     $            0.D+00, 6.379543614D+00, 0.D+00, 1.246096432D+02,   ! l=1
     $            0.D+00, 5.668012809D+03, 0.D+00,                         
     $           -2.489109278D+00, 0.D+00,-7.523702495D+01, 0.D+00,   ! l=2
     $           -2.219441506D+03, 0.D+00,-2.261924024D+04,                
     $            0.D+00, 2.475239283D+00, 0.D+00, 7.425967851D+01,   ! l=3
     $            0.D+00, 6.065395516D+03, 0.D+00,                         
     $            0.D+00, 0.D+00,-1.856218410D+01, 0.D+00,            ! l=4
     $           -1.064260554D+03, 0.D+00,-1.067002097D+04,                
     $            0.D+00, 0.D+00, 0.D+00, 3.247139761D+01,            ! l=5
     $            0.D+00, 4.512684254D+03, 0.D+00,                         
     $            4*0.D+00, -3.409171207D+01, 0.D+00,-2.584954054D+02,! l=6
     $           -1.623728894D+00, 0.D+00,-2.051573007D+01, 0.D+00,   ! l=0, k=3
     $           -4.755286796D+02, 0.D+00,-5.013924376D+03,                     
     $            0.D+00, 7.209456946D+00, 0.D+00, 2.426543363D+02,   ! l=1     
     $            0.D+00, 7.202616237D+03, 0.D+00,                              
     $           -1.532387308D+00, 0.D+00,-4.544278301D+01, 0.D+00,   ! l=2     
     $           -1.105560127D+03, 0.D+00,-1.041686398D+04,                     
     $            0.D+00, 9.558124416D-01, 0.D+00, 9.123860866D+01,   ! l=3     
     $            0.D+00, 3.439411769D+03, 0.D+00,                              
     $            0.D+00, 0.D+00,-1.209421547D+01, 0.D+00,            ! l=4     
     $           -3.768292554D+02, 0.D+00,-3.423818340D+03,                     
     $            0.D+00, 0.D+00, 0.D+00, 2.461404721D+01,            ! l=5     
     $            0.D+00, 1.308525594D+03, 0.D+00,                              
     $            4*0.D+00, -7.310999780D+01, 0.D+00,-5.375235405D+02/! l=6     

C--Long range dispersion coefficients
      DATA ci /   6.183263214D-02, 0.D+00,-4.729079539D+00, 0.D+00,   ! l=0, k=0
     $           -3.887196369D+01, 0.D+00,-3.440241194D+02,                      
     $            0.D+00, 1.348572536D+00, 0.D+00, 9.607359944D+00,   ! l=1     
     $            0.D+00, 8.869588146D+01, 0.D+00,                               
     $            6.183263214D-02, 0.D+00,-5.404662331D+00, 0.D+00,   ! l=2     
     $           -1.888141828D+02, 0.D+00,-5.815676326D+02,                      
     $            0.D+00, 8.990483574D-01, 0.D+00, 2.265356846D+00,   ! l=3     
     $            0.D+00, 2.136122382D+01, 0.D+00,                               
     $            0.D+00, 0.D+00,-4.053496748D+00, 0.D+00,            ! l=4     
     $           -1.190439888D+02, 0.D+00,-2.448956860D+03,                      
     $            0.D+00, 0.D+00, 0.D+00, 2.454430223D-01,            ! l=5     
     $            0.D+00, 2.269164379D+00, 0.D+00,                               
     $            4*0.D+00, -5.222455175D+01, 0.D+00,-2.185798610D+03,! l=6     
     $            6.943366249D-01, 0.D+00, 6.294227341D+00, 0.D+00,   ! l=0, k=1
     $            5.168934484D+01, 0.D+00,-5.230876853D+02,                      
     $            0.D+00,-3.564504443D+00, 0.D+00,-1.369005422D+01,   ! l=1     
     $            0.D+00, 1.406700297D+01, 0.D+00,                               
     $            6.943366249D-01, 0.D+00, 7.193402677D+00, 0.D+00,   ! l=2     
     $            3.802210638D+01, 0.D+00,-1.115389779D+03,                      
     $            0.D+00,-2.376336292D+00, 0.D+00,-3.794139718D+00,   ! l=3     
     $            0.D+00,-7.909685824D+00, 0.D+00,                               
     $            0.D+00, 0.D+00, 5.395052004D+00, 0.D+00,            ! l=4     
     $            1.884558509D+01, 0.D+00,-2.114946373D+03,                      
     $            0.D+00, 0.D+00, 0.D+00,-1.667198562D-01,            ! l=5     
     $            0.D+00, 1.249598638D-02, 0.D+00,                               
     $            4*0.D+00, -4.507312011D+00, 0.D+00,-2.758588364D+03,! l=6     
     $            7.594004123D-01, 0.D+00, 1.535584494D+00, 0.D+00,   ! l=0, k=2
     $            1.265681084D+01, 0.D+00,-1.053005329D+02,                     
     $            0.D+00, 4.189733395D+00, 0.D+00, 5.087469493D+00,   ! l=1     
     $            0.D+00,-7.294163363D+01, 0.D+00,                              
     $            7.594004123D-01, 0.D+00, 1.754953716D+00, 0.D+00,   ! l=2     
     $            1.647658763D+02, 0.D+00,-4.244935083D+02,                     
     $            0.D+00, 2.793155620D+00, 0.D+00, 4.300464650D-01,   ! l=3     
     $            0.D+00,-1.515427768D+01, 0.D+00,                              
     $            0.D+00, 0.D+00, 1.316215320D+00, 0.D+00,            ! l=4     
     $            1.063673863D+02, 0.D+00, 9.733062476D+02,                     
     $            0.D+00, 0.D+00, 0.D+00,-2.222315248D-01,            ! l=5     
     $            0.D+00,-8.888857803D-01, 0.D+00,                              
     $            4*0.D+00, 5.317208211D+01, 0.D+00,-1.630521134D+02, ! l=6     
     $            1.356890690D+00, 0.D+00,-2.087894107D+00, 0.D+00,   ! l=0, k=3
     $           -1.712747765D+01, 0.D+00, 1.737984243D+02,                     
     $            0.D+00, 2.439211487D+00, 0.D+00, 8.703697201D+00,   ! l=1     
     $            0.D+00,-9.580027004D+00, 0.D+00,                              
     $            1.356890690D+00, 0.D+00,-2.386164652D+00, 0.D+00,   ! l=2     
     $            4.562167358D+01, 0.D+00, 2.496131260D+02,                     
     $            0.D+00, 1.626140960D+00, 0.D+00, 3.773289911D+00,   ! l=3     
     $            0.D+00, 1.661817010D+01, 0.D+00,                              
     $            0.D+00, 0.D+00,-1.789623279D+00, 0.D+00,            ! l=4     
     $            3.186336437D+01, 0.D+00, 1.727827304D+03,                     
     $            0.D+00, 0.D+00, 0.D+00, 2.226083618D-01,            ! l=5     
     $            0.D+00, 1.807876534D+00, 0.D+00,                              
     $            4*0.D+00, 2.131138829D+01, 0.D+00, 1.138565305D+03/ ! l=6     

      END
*-------------------------------------------------------------------------------
      SUBROUTINE FILFAC(DLFAC, LOGMAX)
*-------------------------------------------------------------------------------
      IMPLICIT REAL*8 (a-h,o-z)
      DIMENSION dlfac(0:logmax)

      dlfac(0) = 0.d0
      di = 0.d0
      DO i=1,logmax
        di = di + 1.d0
        dlfac(i) = dlfac(i-1) + log(di)
      ENDDO

      END
*-------------------------------------------------------------------------------
      REAL*8 FUNCTION FDAMP(N, R, A, DLFAC, LOGMAX)
*-------------------------------------------------------------------------------
c...
c...  Damping function in Tang-Toennies form:
c...  f_n(R;a) = 1 - exp(-a*R) \sum_i=0^n (a*R)^i / i!
c...
*-------------------------------------------------------------------------------
      IMPLICIT REAL*8 (a-h,o-z)
      DIMENSION dlfac(0:logmax)

      IF (n.gt.logmax) STOP 'logmax too small in function FDAMP'

      tt = 1.d0
      rr = a * r
      DO i=1,n
        tt = tt + rr**i / exp( dlfac(i) )
      ENDDO
      fdamp = 1.d0 - exp(-rr) * tt

      END
*-------------------------------------------------------------------------------
      SUBROUTINE POLLEG (PLEG, LMAX, XCOS)
*-------------------------------------------------------------------------------
      IMPLICIT REAL*8 (a-h,o-z)
      DIMENSION pleg(0:lmax)

      pleg(0) = 1.d0
      pleg(1) = xcos
      di = 0.d0
      DO i=1,lmax-1
        di = di + 1.d0
        pleg(i+1) = ( (2.d0*di + 1.d0) * xcos * pleg(i)
     $                - di * pleg(i-1) ) / (di + 1.d0)
      ENDDO

      END
*===============================================================================
