* System:  NO(X 2Pi)+Xe, initio RCCSD(T) PES's


      subroutine driver
      implicit double precision (a-h,o-z)
      common /cosysr/ xjunk(2),rshift,xfact
      common /covvl/ vvl(11)
      include "common/parpot"
      potnam='Klos et al Xe-NO(X2PI) RCCSDT avtz+33221+ ECP PES'
      print *, potnam
1      print *, ' r (bohr)'
      rshift=0.5
      xfact=0.8
      read (5, *, end=99) r
      call pot(vv0,r)
      write (6, 100) vv0,vvl
100   format(' vsum',/,7(1pe16.8),/,
     :    '  vdif',/,5e16.8)
      goto 1
99    end

      include "common/syusr"
      include "common/bausr"
      include "common/ground"
      subroutine loapot(iunit,filnam)
* ------------------------------------------------------------------------
      character*(*) filnam
      include "common/parbas"
      include "common/parpot"
      potnam='Klos et al Xe-NO(X2PI) RCCSDT avtz+33221+ ECP PES'
** ccsdt potential using avdz+332 basis  for 7 angles **
      lammin(1)=1
      lammax(1)=6
      lammin(2)=2
      lammax(2)=6
      mproj(1)=0
      mproj(2)=2
      ntv(1)=1
      ivcol(1,1)=0
      ivrow(1,1)=0
      return
      end
* ----------------------------------------------------------------------
      subroutine pot (vv0, r)
*  subroutine to calculate the r-dependent coefficients
*  in atomic units (distance and energy)
* ----------------------------------------------------------------------
*  on entry:
*    r:      interparticle distance
*  on return:
*  vv0        contains isotropic term (d00 term in vsum)
*  variable in common block /covvl/
*    vvl:     vector of length 6 to store r-dependence of each term
*             in potential expansion
*    vvl(1-6) expansion coefficients in dl0 (l=1:6) of vsum
*    vvl(7-11) expansion coefficients in dl2 (l=2:6) of vdif

* uses linear least squares routines from cmlib

* author:  millard alexander
* latest revision date:  8-oct-1993
* revised for He-NO(X) : 1-20-95 by Moonbong Yang
* revised for Xe-NO RCCSD(T) PES: 2003.1.1 by Jacek Klos
* 0 degree for Xe-NO and 180 for Xe-ON
* ----------------------------------------------------------------------

      implicit double precision (a-h,o-z)
      dimension xlam1(14),xlam2(14),r0(14),c1(14),c2(14),c3(14),
     :          clr(14),vsum(7),xsum(7),vdif(7),xdif(7),
     :          ddif(7),vap(7),va2p(7),
     :          d0(49),d2(25),aa(64)
      dimension kpvt(8),qraux(7),work(55),rsd(7),re(14)

      common /covvl/ vvl(11)
      data half, zero, one, alph /0.5d0, 0.d0, 1.d0, 1.2d0/
* for distances beyond rmax difference potential is damped
      data rmax /15d0/
* coefficicients for d0 rotation matrices
* stored (by column) for each of 7 angles and for l=0:6
* angles are 0 30 60 90 120 150 180
      data d0/
     : 1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     : 1d0,  8.6602541d-1,  5.0000001d-1,  1.3349125d-8, -4.9999998d-1,
     : -8.6602539d-1, -1d0,
     : 1d0,  6.2500001d-1, -1.2499999d-1, -5.0000000d-1, -1.2500002d-1,
     : 6.2499997d-1,  1d0,
     : 1d0,  3.2475954d-1, -4.3750000d-1, -2.0023687d-8,  4.3750001d-1,
     : -3.2475948d-1, -1d0,
     : 1d0,  2.3437511d-2, -2.8906251d-1,  3.7500000d-1, -2.8906248d-1,
     : 2.3437446d-2,  1d0,
     : 1d0, -2.2327216d-1,  8.9843733d-2,  2.5029609d-8, -8.9843784d-2,
     : 2.2327222d-1, -1d0,
     : 1d0, -3.7402343d-1,  3.2324218d-1, -3.1250000d-1,  3.2324220d-1,
     : -3.7402346d-1,  1d0/
* coefficicients for d2 rotation matrices
* stored (by column) for each of 5 angles and for l=2:6
* angles are 30 60 90 120 150
      data d2/
     : 1.5309311d-1,  4.5927932d-1,  6.1237244d-1,  4.5927934d-1,
     : 1.5309312d-1,
     : 2.9646353d-1,  5.1348990d-1,  1.8279042d-8, -5.1348989d-1,
     : -2.9646355d-1,
     : 4.1999000d-1,  2.2234766d-1, -3.9528471d-1,  2.2234762d-1,
     : 4.1999002d-1,
     : 4.9023048d-1, -1.6982081d-1, -2.4180900d-8,  1.6982085d-1,
     : -4.9023049d-1,
     : 4.8532921d-1, -3.4523418d-1,  3.2021721d-1, -3.4523418d-1,
     : 4.8532920d-1/


* determine A' and A" potentials at angles
      rk=r*0.529177249D0
      do 100 i=1,7
        vap(i)=VAPRIMI(rk,i)
        va2p(i)=VABISI(rk,i)
        vsum(i)=half*(va2p(i)+vap(i))
* don't compute vdif for colinear geometries
        if (i.ne.1 .and. i.ne.7) then
          vdif(i-1)=half*(va2p(i)-vap(i))
* for long range damp out difference potential

          if (r .gt. rmax) then
            damp=-half*(tanh(3.d0*(r-rmax))-one)
            vdif(i-1)=vdif(i-1)*damp
          endif
        endif
100   continue
* solve simultaneous equations for solutions
* first for vsigma
      tol=1.e-10
      call dcopy(49,d0,1,aa,1)
      call dqrank(aa,7,7,7,tol,kr,kpvt,qraux,work)
      call dqrlss(aa,7,7,7,kr,vsum,xsum,rsd,kpvt,qraux)
* convert to hartree
      conv=1.d0/219474.6
      call dscal(7,conv,xsum,1)
      vv0=xsum(1)
      call dcopy(6,xsum(2),1,vvl,1)
      call dcopy(25,d2,1,aa,1)
      call dqrank(aa,5,5,5,tol,kr,kpvt,qraux,work)
      call dqrlss(aa,5,5,5,kr,vdif,xdif,rsd,kpvt,qraux)
      call dscal(5,conv,xdif,1)
      call dcopy(5,xdif,1,vvl(7),1)
      end
*Deck POT

      FUNCTION VAPRIMI(R,N)
CSYSTEM: NO-Xe Aprim state
CLEVEL:RHF/RCCSD(T)/ECP46MWB+TZ33221
C units R=A E=cm-1
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XX(20),XX1(20),XX2(20),XX3(20),
     * XX4(20),XX5(20),XX6(20),XX7(20)
C theta=0
      DATA XX1/
     *   0.224519532775680331D+01,
     *  -0.503402215599918623D+01,
     *  -0.191274049455001601D+07,
     *   0.221406631617273699D+06,
     *   0.666852428879839485D+06,
     *  -0.259526235655994882D+06,
     *  -0.205680585444063727D+05,
     *   0.288186993979026629D+05,
     *  -0.650656338644416610D+04,
     *   0.635320607022624813D+03,
     *  -0.242148867832285148D+02,
     *   0.400851524929575078D+03,
     *   0.148508387668039054D+08,
     *  -0.210726235938842058D+09,
     *   0.104842300505773449D+10,
     *   0.168532433870136083D+04,
     *  -0.284063464127207718D+11,
     *  -0.256173498005467911D+11,
     *   0.359738342157969360D+12,
     *  -0.432915654199125244D+12/
C theta=30
      DATA XX2/
     *   0.261826656942061708D+01,
     *  -0.702068083860408354D+01,
     *  -0.216420321446380764D+07,
     *   0.211954992376762733D+06,
     *   0.680741715100165573D+06,
     *  -0.254071679723299923D+06,
     *  -0.197779987663976135D+05,
     *   0.284578983471864231D+05,
     *  -0.672494488520554296D+04,
     *   0.699399958213010450D+03,
     *  -0.290180470561027448D+02,
     *   0.400851524929575078D+03,
     *   0.256446916568235029D+07,
     *  -0.223492094288287517D+05,
     *   0.556861261881942034D+09,
     *  -0.202855380492230701D+10,
     *  -0.314398615371175117D+11,
     *  -0.283184511543447838D+11,
     *   0.370173214165598083D+12,
     *  -0.403261797811433044D+12/
C theta=60
      DATA XX3/
     *   0.404239181874506226D+01,
     *  -0.838459439354917890D+01,
     *  -0.672534141898681082D+04,
     *  -0.977806404236459057D+06,
     *   0.102416430624802830D+06,
     *  -0.750766485604903137D+05,
     *   0.660207729861389234D+05,
     *   0.922696452005379069D+04,
     *  -0.178685646805732067D+05,
     *   0.483217968039334573D+04,
     *  -0.462727644086063606D+03,
     *   0.400851524929575078D+03,
     *   0.347712288806942105D+07,
     *   0.368672411892638877D+08,
     *  -0.123773530842556977D+10,
     *   0.119396526818820381D+11,
     *  -0.285182522449308243D+11,
     *  -0.869976534080476990D+11,
     *   0.347752655558546326D+12,
     *  -0.291813056207720276D+12/ 
C theta=90
      DATA XX4/
     *   0.416746151246151708D+01,
     *  -0.784095183031804943D+01,
     *   0.493142709615252812D+02,
     *  -0.139884594350979943D+07,
     *   0.422126893360085145D+06,
     *  -0.945207865856177232D+05,
     *   0.198400352947374813D+05,
     *   0.542677854293672408D+04,
     *  -0.135933209358370732D+05,
     *   0.463241795795798589D+04,
     *  -0.595609617551978317D+03,
     *   0.400851524929575078D+03,
     *   0.491232745222185552D+07,
     *  -0.357508594213769212D+07,
     *  -0.881373235836940169D+09,
     *   0.104756485247032528D+11,
     *  -0.283687342638815689D+11,
     *  -0.761894148822298584D+11,
     *   0.364519168116088318D+12,
     *  -0.351998362707445007D+12/      
C theta=120
      DATA XX5/
     *   0.299501234109330738D+01,
     *  -0.251275260667693567D+01,
     *   0.354769948509868514D+07,
     *   0.315901241893567005D+07,
     *  -0.384879923297756526D+06,
     *  -0.560851300100423512D+06,
     *   0.784718618627387186D+05,
     *   0.280456589348548187D+05,
     *  -0.102135719750476619D+05,
     *   0.611368215787297459D+03,
     *   0.453026168402493354D+02,
     *   0.400851524929575078D+03,
     *   0.107094100840428080D+08,
     *  -0.213933933175910026D+09,
     *   0.192555764928091073D+10,
     *  -0.561313645859696007D+10,
     *   0.172668120105872222D+06,
     *  -0.442048751351438761D+09,
     *   0.691027409682091827D+11,
     *  -0.997568298620346527D+11/
C theta=150
      DATA XX6/
     *   0.328356288347027281D+01,
     *  -0.624914531039301213D+01,
     *  -0.532417017344839769D+05,
     *  -0.326740775749183632D+07,
     *   0.298360201148563006D+06,
     *   0.347523452166739517D+05,
     *   0.311066675942042129D+05,
     *  -0.269974999408864733D+04,
     *  -0.113616053500113139D+05,
     *   0.307537994850414452D+04,
     *  -0.278533760549398266D+03,
     *   0.400851524929575078D+03,
     *   0.214650401870967820D+08,
     *  -0.531438569595069468D+09,
     *   0.448060545231907177D+10,
     *  -0.276298247982424974D+10,
     *  -0.736502226033540802D+11,
     *  -0.399787747898975983D+11,
     *   0.813162637292060669D+12,
     *  -0.996193533429287964D+12/
C theta=180
      DATA XX7/
     *   0.294162526368768917D+01,
     *  -0.598077931447039823D+01,
     *  -0.376947083229006827D+07,
     *  -0.138894577380327974D+07,
     *   0.563895660636127112D+06,
     *  -0.131584213135183178D+06,
     *   0.141801475592620037D+02,
     *   0.151091450316677801D+05,
     *  -0.937364639228022497D+04,
     *   0.188353009335419461D+04,
     *  -0.145745383046515883D+03,
     *   0.400851524929575078D+03,
     *   0.672782467547429726D+07,
     *  -0.310654581737209141D+09,
     *   0.490562131903554153D+10,
     *  -0.147200994688906212D+11,
     *  -0.754688979509363098D+11,
     *   0.177397318573002739D+11,
     *   0.887593445861719482D+12,
     *  -0.122528071185272144D+13/

      IF(N.EQ.1) THEN
      DO I=1,20
      XX(I)=XX1(I)
      ENDDO
      ENDIF
      IF(N.EQ.2) THEN
      DO I=1,20
      XX(I)=XX2(I)
      ENDDO
      ENDIF
      IF(N.EQ.3) THEN
      DO I=1,20
      XX(I)=XX3(I)
      ENDDO
      ENDIF
      IF(N.EQ.4) THEN
      DO I=1,20
      XX(I)=XX4(I)
      ENDDO
      ENDIF
      IF(N.EQ.5) THEN
      DO I=1,20
      XX(I)=XX5(I)
      ENDDO
      ENDIF
      IF(N.EQ.6) THEN
      DO I=1,20
      XX(I)=XX6(I)
      ENDDO
      ENDIF
      IF(N.EQ.7) THEN
      DO I=1,20
      XX(I)=XX7(I)
      ENDDO
      ENDIF


      TERM1 = DEXP(-XX(1)*R-XX(2))
      TERM2 = XX(3) + XX(4)*R+XX(5)*R**2+
     *        XX(6)*R**3+XX(7)*R**4+XX(8)*R**5
     *        +XX(9)*R**6+XX(10)*R**7+XX(11)*R**8
      TERM3=0.5D0*
     *   (1.D0+ DTANH(1.D0+XX(12)*R))
      TERM4 = XX(13)/(R**6)+XX(14)/(R**7)
     *        +XX(15)/(R**8)+XX(16)/(R**9)
     *        +XX(17)/(R**10)+XX(18)/(R**11)
     *        +XX(19)/(R**12)+XX(20)/(R**13) 

       VAPRIMI = (TERM1*TERM2-TERM3*TERM4)/4.556335D0
       RETURN
       END

      FUNCTION VABISI(R,N)
CSYSTEM: NO-Xe Abis state
CLEVEL:RHF/RCCSD(T)/ECP46MWB+TZ33221
C units R=A E=cm-1
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XX(20),XX1(20),XX2(20),XX3(20),
     * XX4(20),XX5(20),XX6(20),XX7(20)
C theta=0
      DATA XX1/
     *   0.224519532775680331D+01,
     *  -0.503402215599918623D+01,
     *  -0.191274049455001601D+07,
     *   0.221406631617273699D+06,
     *   0.666852428879839485D+06,
     *  -0.259526235655994882D+06,
     *  -0.205680585444063727D+05,
     *   0.288186993979026629D+05,
     *  -0.650656338644416610D+04,
     *   0.635320607022624813D+03,
     *  -0.242148867832285148D+02,
     *   0.400851524929575078D+03,
     *   0.148508387668039054D+08,
     *  -0.210726235938842058D+09,
     *   0.104842300505773449D+10,
     *   0.168532433870136083D+04,
     *  -0.284063464127207718D+11,
     *  -0.256173498005467911D+11,
     *   0.359738342157969360D+12,
     *  -0.432915654199125244D+12/
C theta=30
      DATA XX2/
     *   0.381436553621524599D+01,
     *  -0.833785192137132292D+01,
     *   0.533627871273067687D+07,
     *  -0.241967582853063382D+07,
     *  -0.872155010239662079D+05,
     *  -0.184563857391624042D+01,
     *   0.991589883720910002D+05,
     *   0.891299761612768998D+04,
     *  -0.201771955270279395D+05,
     *   0.481512039104367341D+04,
     *  -0.383545468047460531D+03,
     *   0.400851524929575078D+03,
     *   0.515115007814553217D+06,
     *   0.791686361833982766D+08,
     *  -0.112524303894491339D+10,
     *   0.970116659724504471D+10,
     *  -0.284074078670259819D+11,
     *  -0.660035286020440750D+11,
     *   0.409782058415318176D+12,
     *  -0.436468978964715454D+12/
C theta=60
      DATA XX3/
     *   0.394113623368748334D+01,
     *  -0.773072448939837376D+01,
     *  -0.481769701799024006D+04,
     *  -0.163553992923195125D+07,
     *   0.387768123161180585D+06,
     *  -0.676948308911488421D+05,
     *   0.372456732316242487D+05,
     *   0.889683532200172340D+04,
     *  -0.146925697683178696D+05,
     *   0.392336594103261359D+04,
     *  -0.390857766719697565D+03,
     *   0.400851524929575078D+03,
     *   0.493498964964629710D+07,
     *  -0.593174280783458147D+07,
     *  -0.824186959182474613D+09,
     *   0.104817722719290886D+11,
     *  -0.290287372999810257D+11,
     *  -0.791555124501509094D+11,
     *   0.359132249373090515D+12,
     *  -0.328282525310140442D+12/
C theta=90
      DATA XX4/
     *   0.400658571548946263D+01,
     *  -0.824350694144501261D+01,
     *   0.421698642416485772D+07,
     *  -0.114473198345487146D+07,
     *   0.775273600356098323D+05,
     *  -0.174911802922386851D+06,
     *   0.533022233664876549D+05,
     *   0.250915049431372099D+05,
     *  -0.141081708076672367D+05,
     *   0.245158926202016664D+04,
     *  -0.171629665139860720D+03,
     *   0.400851524929575078D+03,
     *   0.407570362255164795D+07,
     *   0.261261268386075881D+04,
     *  -0.711999798464161873D+09,
     *   0.903063089239843750D+10,
     *  -0.289549423375153961D+11,
     *  -0.593201844909699402D+11,
     *   0.421697490778588257D+12,
     *  -0.488163226411943359D+12/
C theta=120
      DATA XX5/
     *   0.399976060112793341D+01,
     *  -0.798835750755028862D+01,
     *  -0.478723040187144093D+07,
     *   0.239847691543572637D+04,
     *   0.827395299592267023D+06,
     *  -0.197426342129632656D+06,
     *  -0.301755651032358692D+05,
     *   0.171870322877873296D+05,
     *  -0.717967041226506444D+04,
     *   0.187348214433953922D+04,
     *  -0.238670838738603408D+03,
     *   0.400851524929575078D+03,
     *   0.475753928601777554D+07,
     *  -0.774127082971594017D+07,
     *  -0.724782784748293400D+09,
     *   0.893990350006537819D+10,
     *  -0.219337406759583740D+11,
     *  -0.747452482375734100D+11,
     *   0.263103283087336517D+12,
     *  -0.200510778706795349D+12/
C theta=150
      DATA XX6/
     *   0.498360135946875005D+01,
     *  -0.104339202538571705D+02,
     *  -0.119516257087098900D+07,
     *  -0.455091911900241685D+06,
     *   0.807382104557506274D+06,
     *  -0.471831183228492519D+05,
     *   0.450163706794414611D+04,
     *  -0.700924119831416115D+00,
     *  -0.117213041197513394D+05,
     *   0.605007923421747455D+04,
     *  -0.600215818358752927D+03,
     *   0.400851524929575078D+03,
     *   0.157457468746628193D+07,
     *   0.821833809113343060D+08,
     *  -0.144048257073624659D+10,
     *   0.107316044368142757D+11,
     *  -0.242721240399655952D+11,
     *  -0.644824221666515808D+11,
     *   0.378032401397956909D+12,
     *  -0.441040768801476685D+12/
C theta=180
      DATA XX7/
     *   0.294162526368768917D+01,
     *  -0.598077931447039823D+01,
     *  -0.376947083229006827D+07,
     *  -0.138894577380327974D+07,
     *   0.563895660636127112D+06,
     *  -0.131584213135183178D+06,
     *   0.141801475592620037D+02,
     *   0.151091450316677801D+05,
     *  -0.937364639228022497D+04,
     *   0.188353009335419461D+04,
     *  -0.145745383046515883D+03,
     *   0.400851524929575078D+03,
     *   0.672782467547429726D+07,
     *  -0.310654581737209141D+09,
     *   0.490562131903554153D+10,
     *  -0.147200994688906212D+11,
     *  -0.754688979509363098D+11,
     *   0.177397318573002739D+11,
     *   0.887593445861719482D+12,
     *  -0.122528071185272144D+13/

      IF(N.EQ.1) THEN
      DO I=1,20
      XX(I)=XX1(I)
      ENDDO
      ENDIF
      IF(N.EQ.2) THEN
      DO I=1,20
      XX(I)=XX2(I)
      ENDDO
      ENDIF
      IF(N.EQ.3) THEN
      DO I=1,20
      XX(I)=XX3(I)
      ENDDO
      ENDIF
      IF(N.EQ.4) THEN
      DO I=1,20
      XX(I)=XX4(I)
      ENDDO
      ENDIF
      IF(N.EQ.5) THEN
      DO I=1,20
      XX(I)=XX5(I)
      ENDDO
      ENDIF
      IF(N.EQ.6) THEN
      DO I=1,20
      XX(I)=XX6(I)
      ENDDO
      ENDIF
      IF(N.EQ.7) THEN
      DO I=1,20
      XX(I)=XX7(I)
      ENDDO
      ENDIF


      TERM1 = DEXP(-XX(1)*R-XX(2))
      TERM2 = XX(3) + XX(4)*R+XX(5)*R**2+
     *        XX(6)*R**3+XX(7)*R**4+XX(8)*R**5
     *        +XX(9)*R**6+XX(10)*R**7+XX(11)*R**8
      TERM3=0.5D0*
     *   (1.D0+ DTANH(1.D0+XX(12)*R))
      TERM4 = XX(13)/(R**6)+XX(14)/(R**7)
     *        +XX(15)/(R**8)+XX(16)/(R**9)
     *        +XX(17)/(R**10)+XX(18)/(R**11)
     *        +XX(19)/(R**12)+XX(20)/(R**13) 

       VABISI = (TERM1*TERM2-TERM3*TERM4)/4.556335D0
       RETURN
       END
